
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Block内存管理实例分析 / 憋错料</title>

    <meta name="description" content="Block内存管理实例分析 在ios开发中,相信说道block大家都不陌生,内存管理问题也是开发者最头疼的问题,网上很多讲block的博客,但大都是理论性多点,今天结合一些实例来讲解下. 存储域 首先和大家聊聊block的存储域,根据block在内存中的位置,block被分为三种类型: NSGlobalBlock NSStackBlock NSMallocBlock 从字面意思上大家也可以看出来 NSGlobalBlock是位于全局区的block,它是设置在程序的数据区域(.data区)中. NSStackBlock是位于">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Block内存管理实例分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在<a href="http://xici800.cn/mcRjc2" rel="external nofollow noreferrer">ios开发</a>中，相信说道block大家都不陌生，内存管理问题也是开发者最头疼的问题，网上很多讲block的博客，但大都是理论性多点，今天结合一些实例来讲解下。</p>
<p><strong>存储域</strong></p>
<p>首先和大家聊聊block的存储域，根据block在内存中的位置，block被分为三种类型：</p>
<p>NSGlobalBlock</p>
<p>NSStackBlock</p>
<p>NSMallocBlock</p>
<p>从字面意思上大家也可以看出来</p>
<p>NSGlobalBlock是位于全局区的block，它是设置在程序的数据区域（.data区）中。</p>
<p>NSStackBlock是位于栈区，超出变量作用域，栈上的Block以及&nbsp;__block变量都被销毁。</p>
<p>NSMallocBlock是位于堆区，在变量作用域结束时不受影响。</p>
<p>注意：在&nbsp;ARC&nbsp;开启的情况下，将只会有&nbsp;NSConcreteGlobalBlock&nbsp;和&nbsp;NSConcreteMallocBlock&nbsp;类型的&nbsp;block。</p>
<p>说了这么多理论的东西，有些人可能很懵，觉得讲这些有什么用呢，我平时使用block并没有什么问题啊，好了，接下来我们先来个感受下：</p>
<p>#import "ViewController.h"</p>
<p><strong>void</strong>(^block)(<strong>void</strong>);<strong>@implementation</strong>&nbsp;<strong>ViewController</strong></p>
<p>- (<strong>void</strong>)viewDidLoad {</p>
<p>[<strong>super</strong>&nbsp;viewDidLoad];</p>
<p>NSInteger i = 10;</p>
<p>block = ^{</p>
<p>NSLog(@"%ld", i);</p>
<p>};</p>
<p>}</p>
<p>- (<strong>void</strong>)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {</p>
<p>block();</p>
<p>}</p>
<p><strong>@end</strong></p>
<p>声明这样一个block，点击屏幕的时候去调用这个block，然后就会发生以下错误：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGFuLnhpY2kuY29tL2dyb3VwNC9NMDEvOEQvNzEvckJBQnBsZ1F2VU9FQm1lUkFBQUFBRnBsSVVvODAwLnBuZy8xMDEw.jpg" /></p>
<p>野指针错误，显而易见，这个是生成在栈上的block，因为超出了作用域而被释放，所以再调用的时候报错了，通过打印这个block我们也可以看到是生成在栈上的：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGFuLnhpY2kuY29tL2dyb3VwNS9NMDIvOEQvREMvckJBQnFGZ1F2V2lFZkJJeUFBQUFBRnprU21BMTc4LnBuZy8xMDEw.jpg" /></p>
<p><strong>解决办法</strong></p>
<p>解决办法呢有两种：</p>
<p>Objective-C为块常量的内存管理提供了复制（Block_copy()）和释放（Block_release()）命令。 使用Block_copy()命令可以将块常量复制到堆中，这就像实现了一个将块常量引用作为输入参数并返回相同类型块常量的函数。</p>
<p>- (<strong>void</strong>)viewDidLoad {</p>
<p>[<strong>super</strong>&nbsp;viewDidLoad];</p>
<p>NSInteger i = 10;</p>
<p>block = Block_copy(^{</p>
<p>NSLog(@"%ld", i);</p>
<p>});</p>
<p>}</p>
<p>为了避免内存泄漏，Block_copy()必须与相应的Block_release()命令达到平衡：</p>
<p>Block_release(<strong>block</strong>);</p>
<p>Foundation框架提供了处理块的copy和release方法，这两个方法拥有与Block_copy()和Block_release()函数相同的功能：</p>
<p>- (<strong>void</strong>)viewDidLoad {</p>
<p>[<strong>super</strong>&nbsp;viewDidLoad]; NSInteger i = 10;</p>
<p>block = [^{ NSLog(@"%ld", i);</p>
<p>}&nbsp;<strong>copy</strong>];</p>
<p>}</p>
<p>[block&nbsp;<strong>release</strong>];</p>
<p>到这里有人可能会有疑问了，为什么相同的代码我建了一个工程，没有调用copy，也没有报错啊，并且可以正确打印。 那是因为我们上面的操作都是在MRC下进行的，ARC下编译器已经默认执行了copy操作，所以上面的这个例子就解释了Block超出变量作用域可存在的原因。</p>
<p>接下来可能有人又要问了，block什么时候在全局区，什么时候在栈上，什么时候又在堆上呢？上面的例子是对生成在栈上的Block作了copy操作，如果对另外两种作copy操作，又是什么样的情况呢？</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGFuLnhpY2kuY29tL2dyb3VwNS9NMDIvOEQvRTIvckJBQnFWZ1F2WWlFSmNPVEFBQUFBQ1c4TGxnNjY2LnBuZy8xMDEw.jpg" /></p>
<p>通过这张表我们可以清晰看到三种Block copy之后到底做了什么，接下来我们就来分别看看这三种类型的Block。</p>
<p><strong>NSGlobalBlock</strong></p>
<p>在记述全局变量的地方使用block语法时，生成的block为_NSConcreteGlobalBlock类对象</p>
<p><strong>void</strong>(^block)(<strong>void</strong>) = ^ { NSLog(@"Global Block");};<strong>int</strong>&nbsp;<strong>main</strong>() {</p>
<p>}</p>
<p>在代码不截获自动变量时，生成的block也是在全局区：</p>
<p><strong>int</strong>(^block)(<strong>int</strong>&nbsp;<strong>count</strong>) = ^(<strong>int</strong>&nbsp;<strong>count</strong>) {</p>
<p><strong>return</strong>&nbsp;<strong>count</strong>;</p>
<p>};</p>
<p>block(2);</p>
<p>但是通过clang改写的底层代码指向的是栈区：</p>
<p>impl.isa = &amp;_NSConcreteStackBlock</p>
<p>这里引用巧神的一段话：由于&nbsp;clang&nbsp;改写的具体实现方式和&nbsp;LLVM&nbsp;不太一样，并且这里没有开启&nbsp;ARC。所以这里我们看到&nbsp;isa&nbsp;指向的还是_NSConcreteStackBlock。但在&nbsp;LLVM&nbsp;的实现中，开启&nbsp;ARC&nbsp;时，block&nbsp;应该是&nbsp;_NSConcreteGlobalBlock&nbsp;类型</p>
<p>总结下,生成在全局区block有两种情况：</p>
<p>定义全局变量的地方有block语法时</p>
<p>block语法的表达式中没有使用应截获的自动变量时</p>
<p><strong>NSStackBlock</strong></p>
<p>配置在全局区的block，从变量作用域外也可以通过指针安全地使用。但是设置在栈上的block，如果其作用域结束，该block就被销毁。同样的，由于__block变量也配置在栈上，如果其作用域结束，则该__block变量也会被销毁。</p>
<p>上面举得例子其实就是生成在栈上的block：</p>
<p>NSInteger i = 10;</p>
<p>block = ^{</p>
<p>NSLog(@"%ld", i);</p>
<p>};</p>
<p>除了配置在程序数据区域的block（全局Block），其余生成的block为_NSConcreteStackBlock类对象，且设置在栈上，那么配置在堆上的__NSConcreteMallocBlock类何时使用呢？</p>
<p><strong>NSMallocBlock</strong></p>
<p>Blocks提供了将Block和__block变量从栈上复制到堆上的方法来解决这个问题，这样即使变量作用域结束，堆上的Block依然存在。</p>
<p><strong>impl</strong>.isa = &amp;_NSConcreteMallocBlock;</p>
<p>这也是为什么Block超出变量作用域还可以存在的原因。</p>
<p>那么什么时候栈上的Block会复制到堆上呢？</p>
<p>调用Block的copy实例方法时</p>
<p>Block作为函数返回值返回时</p>
<p>将Block赋值给附有__strong修饰符id类型的类或Block类型成员变量时</p>
<p>将方法名中含有usingBlock的Cocoa框架方法或GCD的API中传递Block时</p>
<p>上面只对Block进行了说明，其实在使用__block变量的Block从栈上复制到堆上时，__block变量也被从栈复制到堆上并被Block所持有。</p>
<p>接下来我们再来看一个????：</p>
<p><strong>void</strong>(^block)(<strong>void</strong>);99<strong>int</strong>&nbsp;main(<strong>int</strong>&nbsp;argc,&nbsp;<strong>const</strong>&nbsp;<strong>char</strong>&nbsp;* argv[]) {</p>
<p><strong>@autoreleasepool</strong>&nbsp;{</p>
<p>__block NSInteger i = 10;</p>
<p>block = [^{</p>
<p>++i;</p>
<p>}&nbsp;<strong>copy</strong>];</p>
<p>++i;</p>
<p>block();</p>
<p>NSLog(@"%ld", i);</p>
<p>}</p>
<p><strong>return</strong>&nbsp;0;</p>
<p>}</p>
<p>我们对这个生成在栈上的block执行了copy操作,Block和__block变量均从栈复制到堆上。</p>
<p>然后在Block作用域之后我们又使用了与Block无关的变量：</p>
<p>++i;</p>
<p>一个是存在于栈上的变量，一个是复制到堆上的变量，我们是如何做到正确的访问这个变量值的呢？</p>
<p>通过clang转换下源码来看下：</p>
<p>void(*block)(void);</p>
<p><strong>struct</strong>&nbsp;<strong>__Block_byref_i_0</strong>&nbsp;{</p>
<p>void *__isa;</p>
<p>__Block_byref_i_0 *__forwarding;</p>
<p><strong>int</strong>&nbsp;__flags;</p>
<p><strong>int</strong>&nbsp;__size;</p>
<p>NSInteger i;</p>
<p>};</p>
<p><strong>struct</strong>&nbsp;<strong>__main_block_impl_0</strong>&nbsp;{</p>
<p><strong>struct</strong>&nbsp;<strong>__block_impl</strong>&nbsp;<strong>impl</strong>;</p>
<p><strong>struct</strong>&nbsp;<strong>__main_block_desc_0</strong>* Desc;</p>
<p>__Block_byref_i_0 *i; // by ref</p>
<p>__main_block_impl_0(void *fp,&nbsp;<strong>struct</strong>&nbsp;<strong>__main_block_desc_0</strong>&nbsp;*desc, __Block_byref_i_0 *_i,&nbsp;<strong>int</strong>&nbsp;flags=0) : i(_i-&gt;__forwarding) {</p>
<p><strong>impl</strong>.isa = &amp;_NSConcreteStackBlock;</p>
<p><strong>impl</strong>.Flags = flags;</p>
<p><strong>impl</strong>.FuncPtr = fp;</p>
<p>Desc = desc;</p>
<p>}</p>
<p>};<strong>static</strong>&nbsp;void __main_block_func_0(<strong>struct</strong>&nbsp;<strong>__main_block_impl_0</strong>&nbsp;*__cself) {</p>
<p>__Block_byref_i_0 *i = __cself-&gt;i; // bound by ref</p>
<p>++(i-&gt;__forwarding-&gt;i);</p>
<p>}<strong>static</strong>&nbsp;void __main_block_copy_0(<strong>struct</strong>&nbsp;<strong>__main_block_impl_0</strong>*dst,&nbsp;<strong>struct</strong>&nbsp;<strong>__main_block_impl_0</strong>*src) {_Block_object_assign((void*)&amp;dst-&gt;i, (void*)src-&gt;i, 8/*BLOCK_FIELD_IS_BYREF*/);}</p>
<p><strong>static</strong>&nbsp;void __main_block_dispose_0(<strong>struct</strong>&nbsp;<strong>__main_block_impl_0</strong>*src) {_Block_object_dispose((void*)src-&gt;i, 8/*BLOCK_FIELD_IS_BYREF*/);}</p>
<p><strong>static</strong>&nbsp;<strong>struct</strong>&nbsp;<strong>__main_block_desc_0</strong>&nbsp;{</p>
<p>size_t reserved;</p>
<p>size_t Block_size;</p>
<p>void (*copy)(<strong>struct</strong>&nbsp;<strong>__main_block_impl_0</strong>*,&nbsp;<strong>struct</strong>&nbsp;<strong>__main_block_impl_0</strong>*);</p>
<p>void (*dispose)(<strong>struct</strong>&nbsp;<strong>__main_block_impl_0</strong>*);</p>
<p>} __main_block_desc_0_DATA = { 0,&nbsp;<strong>sizeof</strong>(<strong>struct</strong>&nbsp;<strong>__main_block_impl_0</strong>), __main_block_copy_0, __main_block_dispose_0};<strong>int</strong>&nbsp;main(<strong>int</strong>&nbsp;argc,&nbsp;<strong>const</strong>&nbsp;<strong>char</strong>&nbsp;* argv[]) {</p>
<p>/* @autoreleasepool */ { __AtAutoreleasePool __autoreleasepool;</p>
<p>__attribute__((__blocks__(byref))) __Block_byref_i_0 i = {(void*)0,(__Block_byref_i_0 *)&amp;i, 0,&nbsp;<strong>sizeof</strong>(__Block_byref_i_0), 10};</p>
<p>block = (void (*)())((id (*)(id, SEL))(void *)objc_msgSend)((id)((void (*)())&amp;__main_block_impl_0((void *)__main_block_func_0, &amp;__main_block_desc_0_DATA, (__Block_byref_i_0 *)&amp;i, 570425344)), sel_registerName("copy"));</p>
<p>++(i.__forwarding-&gt;i);</p>
<p>((void (*)(__block_impl *))((__block_impl *)block)-&gt;FuncPtr)((__block_impl *)block);</p>
<p>NSLog((NSString *)&amp;__NSConstantStringImpl__var_folders_47_s4m8c9pj5mg0k9mymsm7rbmw0000gn_T_main_e69554_mi_0, (i.__forwarding-&gt;i));</p>
<p>}</p>
<p><strong>return</strong>&nbsp;0;</p>
<p>}</p>
<p>static struct IMAGE_INFO { unsigned version; unsigned flag; } _OBJC_IMAGE_INFO = { 0, 2 };</p>
<p>我们发现相比于没有__block关键字修饰的变量，源码中增加了一个名为&nbsp;__Block_byref_i_0&nbsp;的结构体，用来保存我们要&nbsp;capture&nbsp;并且修改的变量&nbsp;i。</p>
<p>在__Block_byref_i_0结构体中我们可以看到成员变量__forwarding,它持有指向该实例自身的指针。那么为什么会有这个成员变量__forwarding呢？这也是正是问题的关键。</p>
<p>我们可以看到源码中这样一句：</p>
<p>++(i-&gt;__forwarding-&gt;i);</p>
<p>栈上的__block变量复制到堆上时，会将成员变量__forwarding的值替换为复制到堆上的__block变量用结构体实例的地址。所以“不管__block变量配置在栈上还是堆上，都能够正确的访问该变量”，这也是成员变量__forwarding存在的理由。</p>
<p><strong>循环引用</strong></p>
<p>循环引用比较简单，造成循环引用的原因无非就是对象和block相互强引用，造成谁都不能释放，从而造成了内存泄漏。基本的一些例子我就不再重复了，网上很多，也比较简单，我就一个问题来讨论下，也是开发中有人问过我的一个问题：</p>
<p>block里面使用self会造成循环引用吗？</p>
<p>很显然答案不都是，有些情况下是可以直接使用self的，比如调用系统的方法：</p>
<p>[<strong>UIView</strong>&nbsp;animateWithDuration:0.5 animations:^{</p>
<p>NSLog(<strong>@</strong>"%@", self);</p>
<p>}];</p>
<p>因为这个block存在于静态方法中，虽然block对self强引用着，但是self却不持有这个静态方法，所以完全可以在block内部使用self。</p>
<p>还有一种情况：</p>
<p>当block不是self的属性时，self并不持有这个block，所以也不存在循环引用</p>
<p><strong>void</strong>(^block)(<strong>void</strong>) = ^() {</p>
<p>NSLog(@"%@",&nbsp;<strong>self</strong>);</p>
<p>};</p>
<p>block();</p>
<p>只要我们抓住循环引用的本质，就不难理解这些东西。</p>
<p>希望可以通过上面的一些例子，可以让大家加深对block的理解，知其然并且知其所以然。</p>
<p>文章来源：CocoaChina</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 23:01:46 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Block内存管理实例分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02ZAlB0.html" rel="bookmark">java内存管理的分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java 中的内存分为四个部分: stack(栈):存放基本类型的数据和对象的引用,即存放局部变量. Note: 如果存放的是基本类型数据(非静态变量),则直接将变量名和值存入stack中. 如果存放的是引用类型,则将变量名存入栈,然后指向它new出的对象(存放在堆中). heap(堆)存放 new 出来的东西. data segment(数据区):分为静态区和常量区(常量池) 静态区(static segment): 存放在对象中用 static 定义的静态成员(即静态变量,如果该静态变量是基			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mo9bAn3.html" rel="bookmark">iOS学习之block总结及block内存管理（必看）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Block简介(copy一段) Block作为C语言的扩展,并不是高新技术,和其他语言的闭包或lambda表达式是一回事.需要注意的是由于Objective-C在iOS中不支持GC机制,使用Block必须自己管理内存,而内存管理正是使用Block坑最多的地方,错误的内存管理 要么导致return cycle内存泄漏要么内存被提前释放导致crash. Block的使用很像函数指针,不过与函数最大的不同是:Block可以访问函数以外.词法作用域以内的外部变量的值.换句话说,Block不仅 实现函数的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmGYxD3.html" rel="bookmark">对 block 内存管理的一些看法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先交代一下retain cycle ,和 产生retain cycle后我们应该怎么处理. 1.retain cycle在block中是极易产生,block就是一段可以灵活使用的代码,你可以把它当做变量传递,赋值,甚至可以把它声明到函数体中.更加灵活的是它可以引用它的承载着(即就是block的运行环境),但是这样子就更容易产生retain cycle了 .就是简单说类比 子控件拥有父控件的引用,而父控件也拥有子控件的引用.这样相互引用.就不能形成父控件释放也能将子控件释放.这就造成一个内存泄露			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NGlqwM.html" rel="bookmark">iOS中引用计数内存管理机制分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 iOS 中引用计数是内存的管理方式,尽管在 iOS5 版本号中.已经支持了自己主动引用计数管理模式.但理解它的执行方式有助于我们了解程序的执行原理.有助于 debug 程序. 操作系统的内存管理分成堆和栈. 在堆中分配的内存,都试用引用计数模式:在栈中则不是. NSString 定义的对象是保存在栈中,所以它没有引用计算.看一些书上说它的引用计算会是 fffffffff 最大整数.測试的结果显示它是- 1. 对该对象进行 retain 操作.不好改变它的 retainCount 值. Mut			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jnVKg0.html" rel="bookmark">Linux内核内存管理子系统分析【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文转载自:http://blog.csdn.net/coding__madman/article/details/51298718 版权声明:本文为博主原创文章,未经博主允许不得转载. 还是那张熟悉的老图:Linux内核子系统简介(由七个部分组成) Linux内存管理模型: 1. 内存管子系统职能: 1&gt;  管理虚拟地址与物理地址的映射 2&gt;  管理物理内存的分配 2. 地址映射管理 1&gt; 虚拟地址空间分布: linux采用的是一种虚拟地址的管理方式,对于一个32位的处理器对于的内存空			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mzyadq4.html" rel="bookmark">iOS中引用计数内存管理机制分析总结（NSString引用计数为-1的情况）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 iOS 中引用计数是内存的管理方式,虽然在 iOS5 版本中,已经支持了自动引用计数管理模式,但理解它的运行方式有助于我们了解程序的运行原理,有助于 debug 程序.   操作系统的内存管理分成堆和栈. 在堆中分配的内存,都适用引用计数模式:在栈中则不是. NSString 定义的对象是保存在栈中,所以它没有引用计数,不是通过引用计数对内存进行管理的.之前我在一篇博客上看,说常量的引用计数会是一个很大的整数,测试的结果显示它是-1. 对该对象进行 retain 操作,不好改变它的 reta			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02dLkz4.html" rel="bookmark">memcached内存管理机制分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				memached是高性能分布式内存对象系统,通过在内存中存储数据对象来减少对磁盘的数据读取次数,提高服务速度. 从业务需求出发.我们通过一条命令(如set)将一条键值对(key,value)插入memcached后,需要: 1.对该键值数据的高效索引: (memcached通过哈希表来对键值数据进行管理,具体的实现中采用链接法来处理hash冲突问题.) 2.系统可能会频繁的创建新数据和删除旧数据,需要高效的内存管理: (最简单的思路是来了新的数据就malloc内存,将新数据保存在这段新分配的内存			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MobPdk4.html" rel="bookmark">深入C&num;内存管理来分析值类型&amp;amp&semi;引用类型，装箱&amp;amp&semi;拆箱，堆栈几个概念组合之间的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C#初学者经常被问的几道辨析题,值类型与引用类型,装箱与拆箱,堆栈,这几个概念组合之间区别,看完此篇应该可以解惑. 俗话说,用思想编程的是文艺程序猿,用经验编程的是普通程序猿,用复制粘贴编程的是2B程序猿,开个玩笑^_^. 相信有过C#面试经历的人,对下面这句话一定不陌生: 值类型直接存储其值,引用类型存储对值的引用,值类型存在堆栈上,引用类型存储在托管堆上,值类型转为引用类型叫做装箱,引用类型转为值类型叫拆箱. 但仅仅背过这句话是不够的. C#程序员不必手工管理内存,但要编写高效的代码,就仍需			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQPg73.html" rel="bookmark">Block内存管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				block是不是一个对象?是一个对象 如何判断当前文件是MRC,还是ARC 1.dealloc 能否调用super,只有MRC才能调用super 2.能否使用retain,release.如果能用就是MRC ARC管理原则:只要一个对象没有被强指针修饰就会被销毁,默认局部变量对象都是强指针,存放到堆里面 MRC了解开发常识:1.MRC没有strong,weak,局部变量对象就是相当于基本数据类型 2.MRC给成员属性赋值,一定要使用set方法,不能直接访问下划线成员属性赋值 总结:只要block			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0brK90.html" rel="bookmark" class="title">37-more  简明笔记</a>
					<div>
						分页显示文本 more [options] file more用于分页显示文本文件,最早出现在BSD当中,但这一命令非常基本,后来less命令对其做了增强,所谓的less也就是少即是多 参数 file ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418yPG3.html" rel="bookmark" class="title">mac下通过docker搭建LEMP环境</a>
					<div>
						在mac下通过docker搭建LEMP环境境 1.安装virtualbox.由于docker是在lxc环境的容器 2.安装boot2docker,用于与docker客户端通讯 &gt; brew up ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nk9KK3.html" rel="bookmark" class="title">用HTML5的File API做上传图片预览功能</a>
					<div>
						用HTML5的File API做上传图片预览功能 前几天做了一个项目,涉及到上传本地图片的功能,正好之前了解过 html5 可以上传本地图片,然后再网上看了一些demo结合自己的需求,终于搞定了.(P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQlDgM.html" rel="bookmark" class="title">oracle学习第五天</a>
					<div>
						视图 什么是视图视图(VIEW)也被称作虚表,也就是虚拟的表,是一组数据的逻辑表示.视图对应一个select语句,结果集被赋予一个名字,就是视图的名字视图本身不包含任何数据,它只是包含映射到基表的一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41oRvY0.html" rel="bookmark" class="title">企业信息安全的管理与防范</a>
					<div>
						虽然中国信息安全行业起步相对较晚,但至今为止,大家的信息安全意识都越来越强烈,加上政府重视和政策扶持,也不断推动中国信息安全产业的快速发展,使得网络和信息安全得到了越来越多政府机构和企业的关注和重视. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0leJvP3.html" rel="bookmark" class="title">规范化的国际化给大家的个同意将都搞好</a>
					<div>
						http://t.lcxw.cn/vote/view/vid-2292378 http://t.lcxw.cn/vote/view/vid-2292369 http://t.lcxw.cn/vote/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbewvM.html" rel="bookmark" class="title">JAVA常用关键字</a>
					<div>
						Java 中常用关键字: 一一解释(先以印象注明含义,若有错误或未填写的待用到后补充.更新):(蓝色为不确定部分) abstract : 虚类 boolean : 类型定义——布尔型 break :  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35reOE4.html" rel="bookmark" class="title">实现文件在线浏览和下载</a>
					<div>
						有时候我们可能需要设置这种 在html页面中实现,点击按钮,将文件在弹出框中展示出来,并且实现下载功能 1.下载功能(不兼容ie8) 因为html5给a标签新添加了一个属性download,这个属性可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6ovX0.html" rel="bookmark" class="title">VM虚拟机下centos7 无法上网的问题解决办法</a>
					<div>
						博主本着学无止境的精神在虚拟机上安装了一个centos7 来敲敲命令行.刚开始就遇到了强大的阻力... ifconfig   vim  都没法用.这怎么行,安装呗.又学了圈安装,yum命令. 结果yu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Moo8WkM.html" rel="bookmark" class="title">提高篇项目3（2）&mdash;&mdash;求最大公约数</a>
					<div>
						任务及代码 /* *Copyright (c)2016,csdn学院 *All rights reserved. *文件名称:lzz.c *作 者:兰泽泽 *完成日期:2016年5月8日 *版 本 号 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qOlo5M.html" rel="bookmark" class="title">各种主流浏览器内核引擎的对比分析</a>
					<div>
						要搞清楚浏览器内核是什么,首先应该先搞清楚浏览器的构成.简单来说浏览器可以分为 两部分,shell+内核.其中shell的种类相对比较多,内核则比较少.Shell是指浏览器的外壳:例如菜单,工具栏等. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38rwz1M.html" rel="bookmark" class="title">Android NDK使用addr2line符号化得到错误函数名的问题</a>
					<div>
						一般Android NDK出现崩溃之后,我们会使用addr2line工具来进行符号化.如果你使用了C++11的一些特性,那么要注意了,有可能你将得到错误的函数名.我们公司是提供崩溃分析相关的服务的,采 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPX2ZzM.html" rel="bookmark" class="title">对象自动装配器</a>
					<div>
						一.有朋友说数据封装到对象很是麻烦,最喜欢hibernate的地方就是操作数据简单了.其实我想说的是框架都是对基本操作的高级封装.就如数据封装到对象,闲来无事,就简单做了个对象自动装配器.大家可以研究 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KP6Er3.html" rel="bookmark" class="title">LeetCode：Merge Two Sorted Lists</a>
					<div>
						题目:Merge Two Sorted Lists Merge two sorted linked lists and return it as a new list. The new list sh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGnLQa4.html" rel="bookmark" class="title">大型网站技术1-----虚拟化</a>
					<div>
						大型网站技术之虚拟化 牛人就不要看了~ 1.引言 先举个例子,一台物理主机有16G内存,用户A的程序只需要2G内存,用户B的程序只需要4G内存,如果没有用虚拟化技术,他们的解决方案如下: 两用户程序放 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AneeyM.html" rel="bookmark" class="title">Android Parcel初识</a>
					<div>
						先附上一个连接,这里讲的非常详细,感谢此文作者http://www.cnblogs.com/renqingping/archive/2012/10/25/Parcelable.html 用Parcel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eardZ0.html" rel="bookmark" class="title">Android GridView加载大量图片时出现OOM情况</a>
					<div>
						最近写的一个应用涉及到使用GridView显示图片,当使用BaseAdapter传统的的实现时,在真机上快速滚动时会出现OOM情况. 一个临时性的解决方案就是改动图片尺寸,减小内存.这种方法简单却不安 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ba28LM.html" rel="bookmark" class="title">查找一个数组中最小的前n项</a>
					<div>
						/****************************************************************** find the biggest x number in a s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dP9rr0.html" rel="bookmark" class="title">android 反编译 for mac</a>
					<div>
						android反编译现在来说的话很方便. windows上有不好好用的工具,当然我比较喜欢dex2jar 这个是比较好用的,打开他的文件目录会发现,里面有很多.sh .bat文件 那也就是说在wind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rOBv14.html" rel="bookmark" class="title">UnityTestTools測试工具</a>
					<div>
						由于工作关系,要了解Unity上的測试工具,该工具基于Nunit框架.通过查阅资料了解到在Unity5.3中做出了一些改变,自带的仅仅剩下单元測试工具,假设想用其它的工具比方断言.集成測试,就须要前往 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
